/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  ftable.h
    ⥸塼ơ֥
*********************************************************************/

#ifndef	FTABLE_H
#define	FTABLE_H

#include "def.h"
#include "node.h"
#include "table.h"

// ftype ǻȤ
enum ftype_t {
    ft_null, ft_ipu_p, ft_cxx
};

class ftable : public table
{
  private:
    int 	i_num;	// ϲο
    int 	o_num;	// ϲο
    int 	p_num;	// ѥ᡼ο
    ftype_t 	ftype;	// ץΥ (ft_ipu_p or ft_cxx)
  public:
    inline ftable() {};
    inline ftable(char* nam, int in, int out, int param, table* n)
	:table(0, nam, n), i_num(in), o_num(out), p_num(param) {};
    inline ~ftable() {};

    inline void def(char* nam, int in, int out, int param)
    {
	table* p = table::ser(nam);
	if (p != NULL) {
	    ((ftable*)p)->i_num = in;
	    ((ftable*)p)->o_num = out;
	    ((ftable*)p)->p_num = param;
	} else {
	    next = new ftable(nam, in, out, param, next);
	}
    };

    inline int get(char* nam, int& in, int& out, int& param)
    {
	table* p = table::ser(nam);
	if (p != NULL) {
	    in    = ((ftable*)p)->i_num;
	    out   = ((ftable*)p)->o_num;
	    param = ((ftable*)p)->p_num;
	    return OKAY;
	} else {
	    return FAIL;
	}
    };

    inline void settype(char* nam, ftype_t t)
    {
	table* p = table::ser(nam);
	if (p != NULL) {
	    ((ftable*)p)->ftype = t;
	}
    }

    inline ftype_t gettype(char* nam)
    {
	table* p = table::ser(nam);
	if (p != NULL) {
	    return ((ftable*)p)->ftype;
	} else {
	    return ft_null;
	}
    };
};

#endif /* FTABLE_H */
