/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  jobid.h
*********************************************************************/

#ifndef JOBID_H
#define JOBID_H

#define jobid_to_ip1no(j)		((j) / 10000)
#define jobid_to_taskid(j)		((j) % 10000)
#define taskid_ip1no_to_jobid(t,i)	\
	(((t >= 10000) && taskid_error()), (i)*10000 + (t))

#include <stdlib.h>
static int
taskid_error()
{
    (void)taskid_error;
    fprintf(stderr, "task id overflow\n");
    abort();
    return 0;
}

#endif /* JOBID_H */
