/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  DivisionList.h
    ʬ˴ؤ
    ʬʬñ̤ʬݻ
*********************************************************************/

#ifndef DIVISIONLIST_H
#define DIVISIONLIST_H

#include "ObjPartList.h"
#include "div.h"
#include "vios.h"

class DivisionList
{
  private:
    DivisionList*	next;
    div_type		dividetype;
    int 		exist_flag; // ʬ¸ߤ뤫
				    // 0:¸ߤʤ 1: 2:¸ߤ
    ObjPartList 	mini_img;
    DivisionList*	search(div_type d_type);

  public:
    //󥹥ȥ饯
    DivisionList();
    DivisionList(DivisionList* n, int d_id, div_type d_type, int w, int h,
		 int hx, int hy, int ca, int ipu_no);
    // ǥȥ饯
    ~DivisionList();

    // ä
    void append(int d_id, div_type d_type, int w, int h, int hx, int hy,
		int ca, int ipu_no);
    // ʬ ID ǲä
    int append(int d_id, int ipu_no);

    // Υۥ̾
    void remove_host(div_type d_type, int d_id, int ipu_no);
    // Υ֥ȥѡȤ
    void remove_objpart(div_type d_type, int d_id);
    // ʬñ̤
    void remove_division(div_type d_type);

    // ʬΥۥȤˤ뤫ɤ
    //  OKAY ʤ FAIL ֤
    int obj_part_exist_this_host(int d_id, int ipu_no);

    // ʬ䥿פʬäƤۥ֤̾
    //  OKAY ʤ FAIL ֤
    int get_part_image_host(div_type d_type, int d_id, int* ipu_no_ret);
    // ʬäƤۥ֤̾
    //  OKAY ʤ FAIL ֤
    int get_part_image_host(int d_id, int* ipu_no_ret);
    // ʬ䥿פʬäƤۥ֤̾
    //  OKAY ʤ FAIL ֤
    int get_part_image_host(div_type d_type, int x, int y,
			    int* ipu_no_ret, int* div_id_ret);

    // β礭֤
    int get_image_size(div_type d_type, int d_id, int* w, int* h);
    // βΥۥåȥݥȤ֤
    int get_image_hot(div_type d_type, int d_id, int* hx, int* hy);
    // β cache ֤
    int get_image_cache(div_type d_type, int d_id, int* ca);

    // ʬ䥿פ뤫ɤ
    //  OKAY ʤ FAIL ֤
    int DivideTypeExist(div_type d_type);

    // ʬñ̤뤫ɤ֤
    // 0:¸ߤʤ 1: 2:¸ߤ
    int get_divide_type_exist(div_type d_type);
    // ʬñ̤¸ߤ򥻥å
    int set_divide_type_exist(div_type d_type, int exist);

    // ǥХå
  private:
    void print_sub(int indent_level = 0);
  public:
    void print(int indent_level = 0);
};

#endif /* DIVISIONLIST_H */
