/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  ObjPartList.h
    ֥ȥѡ ()
    ʬ
*********************************************************************/

#ifndef OBJPARTLIST_H
#define OBJPARTLIST_H

#include "MachineList.h"
#include "vios.h"

class ObjPartList
{
  private:
    ObjPartList*	next;
    int 		div_id; // ʬ ID
    int 		width, height;
    int 		hot_x, hot_y;
    int 		cache;
    MachineList 	ipus;

    ObjPartList(ObjPartList* n, int d_id, int w, int h, int hx, int hy,
		int ca, int ipu_no);
    ObjPartList* ObjPartList::search(int d_id);

  public:
    ObjPartList();
    ~ObjPartList();

    // ֥ȥѡȥꥹȤ˥֥ȥѡȤä
    void append(int d_id, int w, int h, int hx, int hy, int ca, int ipu_no);

    // ʬ̾ȥۥ̾ǥ֥Ȥä
    int append(int d_id, int ipu_no);

    //  IPU 
    void remove_host(int d_id, int ipu_no);

    // Υ֥ȥѡȤ
    void remove_objpart(int d_id);

    // ʬΥۥȤˤ뤫ɤ
    //  OKAY ʤ FAIL ֤
    int obj_part_exist_this_host(int d_id, int ipu_no);

    // ʬäƤۥ֤̾
    //  OKAY ʤ FAIL ֤
    int get_part_image_host(int d_id, int* ipu_no_ret);
    // ʬäƤۥ֤̾
    //  OKAY ʤ FAIL ֤
    int get_part_image_host(int x, int y, int* ipu_no_ret, int* div_id_ret);

    // ʬ礭֤
    int get_image_size(int d_id, int* w, int* h);
    // ʬΥۥåȥݥȤ֤
    int get_image_hot(int d_id, int* hx, int* hy);
    // ʬ cache ֤
    int get_image_cache(int d_id, int* ca);

    // ǥХå
  private:
    void print_sub(int indent_level = 0);
  public:
    void print(int indent_level = 0);
};

#endif /* OBJPARTLIST_H */
