/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  div.h  ʬη
*********************************************************************/

#ifndef DIV_H
#define DIV_H

typedef enum {
    dt_null, dt_pixel, dt_column, dt_row, dt_box, dt_all
} div_type;

static char*
dt2string(div_type dt)
{
    (void)dt2string;
    switch (dt) {
      case dt_null:   return "null";
      case dt_pixel:  return "pixel";
      case dt_column: return "column";
      case dt_row:    return "row";
      case dt_box:    return "box";
      case dt_all:    return "all";
      default:        return "unknown";
    }
}

#endif /* DIV_H */
