/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  etc.cc
    ¾ν
*********************************************************************/

#include <string.h>
#include <stdio.h>
#include "etc.h"

// strdup  new Ƚ
char*
strdup_new(char* s)
{
    int   len;
    char* p;

    len = strlen(s);
    p = new char[len+1];
    strcpy(p, s);
    return p;
}

char*
strip_name(char* token)
{
    if (*token != '/') {
	return NULL;
    }
    return strdup_new(token+1);
}

char*
strip_string(char* token)
{
    char*	s;
    int 	len;

    len = strlen(token);
    if (token[0] != '(' || token[len-1] != ')') {
	return NULL;
    }
    s = new char[len-2+1];
    strncpy(s, token+1, len-2);
    s[len-2] = '\0';
    return s;
}

// ӥåǥͤǼӼФ (̿ʤɤ˻Ȥ)
void
setint(void* buf, int value)
{
    unsigned char* p = (unsigned char*)buf;
    p[0] = (value >> 24) & 0xff;
    p[1] = (value >> 16) & 0xff;
    p[2] = (value >>  8) & 0xff;
    p[3] = (value      ) & 0xff;
}

int
getint(void* buf)
{
    unsigned char* p = (unsigned char*)buf;
    return (p[0] << 24) | (p[1] << 16) | (p[2] << 8) | p[3];
}
