/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  main.cc
    OM ᥤ
*********************************************************************/

#include <stdlib.h>
#include <pthread.h>
#include <unistd.h>
#include "vios.h"
#include "msgqueue.h"
#include "IpuList.h"
#include "ObjectList.h"
#include "VarList.h"
#include "TaskData.h"
#include "ModuleList.h"
#include "com.h"
#include "vpe_p.h"
#include "done_report.h"
#include "schedule.h"
#include "port.h"

msgqueue	send_q[64];	// IPUå
msgqueue	com_q;		// VPE饳ѥå
msgqueue	done_q;		// IPUädone_report
msgqueue	sche_q;		// ѥ餫饹塼
msgqueue	vpe_send_q;	// OM  VPE 

IpuList		ip;
VarList		va_array; // array 
ModuleList	mo;
ObjectList	ob;
TaskData	td;

int
main(int argc, char* argv[])
{
    int* port = new int;

    *port = get_om_port();

    // 
    int i;
    for (i = 1; i < argc; i++) {
	if ((strcmp(argv[i], "-port") == 0 ||
	     strcmp(argv[i], "-p"   ) == 0   ) && (i+1 < argc))
	{
	    i++;
	    *port = atoi(argv[i]);
	} else {
	    fprintf(stderr, "usage: %s [-p port]\n",
		    argv[0]);
	    return 1;
	}
    }

    // OM εǽ

    pthread_t tid;
    pthread_attr_t attr;
    struct sched_param sparam;
    pthread_attr_init(&attr);
    pthread_attr_setscope(&attr, PTHREAD_SCOPE_SYSTEM);
    pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);

    // ̿ѥå
    sparam.sched_priority = 5;
    pthread_attr_setschedparam(&attr, &sparam);
    pthread_create(&tid, &attr, (void* (*)(void*))comm, port);

    // done_report 륹å
    sparam.sched_priority = 5;
    pthread_attr_setschedparam(&attr, &sparam);
    pthread_create(&tid, &attr, (void* (*)(void*))done_report, NULL);

    // ѥ (VPE ץबƤư)
    sparam.sched_priority = 5;
    pthread_attr_setschedparam(&attr, &sparam);
    pthread_create(&tid, &attr, (void* (*)(void*))vpe_p, NULL);

    // 塼
    sparam.sched_priority = 5;
    pthread_attr_setschedparam(&attr, &sparam);
    pthread_create(&tid, &attr, (void* (*)(void*))scheduler, NULL);

    pthread_attr_destroy(&attr);

    pthread_exit(0);

    return 0;
}
