/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  pragma.h
*********************************************************************/

#ifndef PRAGMA_H
#define PRAGMA_H

#define PG_MUTEX_DEFAULT	0
#define PG_MUTEX_ON		1
#define PG_MUTEX_OFF		2
#define PG_MUTEX_OFF_MAX	3
#define PG_MUTEX_OFF_MIN	4
#define PG_MUTEX_OFF_DMAX	5
#define PG_MUTEX_OFF_DMIN	6
#define PG_MUTEX_OFF_ADD	7

#define PG_BOUNDARY_DEFAULT	0
#define PG_BOUNDARY_NOCHECK	1
#define PG_BOUNDARY_GET		2
#define PG_BOUNDARY_COMPLETE	3
#define PG_BOUNDARY_CONST	4

#define PG_DIVTYPE_DEFAULT	0
#define PG_DIVTYPE_BOX		1
#define PG_DIVTYPE_ROW		2
#define PG_DIVTYPE_COLUMN	3

/* prototypes */

int	pragma_init(void);
int	pragma_term(void);
int	parse_pragma(char *);
int	search_pragma_mutex(char *varname);
int	search_pragma_boundary(char *varname, char **cont_val_ret);
int	search_pragma_divtype(char *module_name);

#endif /* PRAGMA_H */
