// Hough_inverse.v եϥѴ⥸塼

#define SIZE 512
#define MAX_INT 2147483647

module Hough_inverse(in:input,out:parameter)
int in on pixel;
int out[SIZE][SIZE];
#vios mutex out off min
{

    {
	int x,y;
	// ϲ˽ޤ
	for(y = 0; y < SIZE; y++){
	    for(x = 0; x < SIZE; x++){
		out[x][y] = 255;
	    }
	}
    }

    parallel{
	// ϤβΤʬˤĤ
	// եϥѴԤʤޤ
	if(in[][] != 0){
	    int x,y;
	    int rho_int,theta;
	    float rho,rad;
	    float diag;
	    float sin_inv,cos_inv,tan_inv;
	    float sinx,cosx,tanx;

	    // κɸȡѤޤ
	    theta = hotx(in);
	    rho_int = hoty(in);

	    // гĹ׻ޤ
	    diag = sqrt((float)(2*SIZE*SIZE));
	    
	    // Ȥ饸Ѵޤ
	    rad = (float)theta*M_PI/width(in);
	    // int˴ݤƤѤ鸵ͤޤ
	    rho = 2*(rho_int - 0.5)*diag/height(in) - diag;
	    
	    // Ԥƥ󡢥󡢥󥸥Ȥͤ׻ޤ
	    sinx = sin(rad);
	    cosx = cos(rad);
	    tanx = tan(rad);

	    // տ׻ޤ
	    if(sinx == 0.) sin_inv = MAX_INT;
	    else sin_inv = 1./sinx;
	    
	    if(cosx == 0.) cos_inv = MAX_INT;
	    else cos_inv = 1./cosx;

	    if(tanx == 0.) tan_inv = MAX_INT;
	    else tan_inv = 1./tanx;
	    

	    // ԤƷ׻줿ѥ᡼
	    // x,yʿ̤ľץåȤޤ
	    if(-1. <= tan_inv && tan_inv <= 1.){
		for(x = 0; x < SIZE; x++){
		    y = (int)(rho*sin_inv - x*tan_inv);
		    if(0 <= y && y < SIZE) out[x][y] = 0;
		}
	    }
	    else{
		for(y = 0; y < SIZE; y++){
		    x = (int)(rho*cos_inv - y*tanx);
		    if(0 <= x && x < SIZE) out[x][y] = 0;
		}
	    }
	}
    }
}
