// Snake.v ͡ǥѤسԸ

#define P_NUM 60      // ߼Υץåȿ
#define BOX_SIZE 8    // 󥰥åȤ礭
#define NO_USE -1     // å󳰤ΰ˥ݤβ

// ΤĤʤ餫ˤ뤿Υͥ륮׻ޤ
float CalcAngle(int pre_x, int pre_y,
		 int x,     int y,
		 int next_x,int next_y)
{
    int Vec1_x,Vec1_y;   // preȤδ֤˰٥ȥʬ
    float Vec1_size;     // Ʊ礭
    
    int Vec2_x,Vec2_y;   // nextȤδ֤˰٥ȥʬ
    float Vec2_size;     // Ʊ礭
    
    float I_product;     // 2ĤΥ٥ȥΤʤ
    float CosTheta;       // 2ĤΥ٥ȥΤʤ٤Υ
    
    // 2Ȥδ֤˰٥ȥʬ顢Υ٥ȥ
    // 礭׻ޤ
    Vec1_x = x-pre_x;
    Vec1_y = y-pre_y;
    Vec1_size = sqrt((float)(Vec1_x*Vec1_x + Vec1_y*Vec1_y));
    // ȽŤʤäƤ0֤ޤ
    if(Vec1_size == 0.){
	return 0.;
    }
    Vec2_x = x-next_x;
    Vec2_y = y-next_y;
    Vec2_size = sqrt((float)(Vec2_x*Vec2_x + Vec2_y*Vec2_y));
    // ȽŤʤäƤ0֤ޤ
    if(Vec2_size == 0.) return 0.;

    // 2ĤΥ٥ȥʬ顢Ѥ׻ޤ
    I_product = (float)(Vec1_x*Vec2_x + Vec1_y*Vec2_y);
    
    // 2٥ȥѤ礭顢ͤޤ
    CosTheta = I_product/(Vec1_size*Vec2_size);
    
    // ٤륨ͥ륮Ȥ֤ͤޤ
    if(CosTheta > 0) return CosTheta;
    else             return CosTheta/2;
}

// ֤εΥ褦Ȥ륨ͥ륮׻ޤ
float CalcDist(int pre_x, int pre_y,
	       int x,     int y,
	       int next_x,int next_y)
{
    int Vec1_x,Vec1_y;   // preȤδ֤˰٥ȥʬ
    float Vec1_size;     // Ʊ礭
    
    int Vec2_x,Vec2_y;   // nextȤδ֤˰٥ȥʬ
    float Vec2_size;     // Ʊ礭
    
    float Diff;          // 2ĤΥ٥ȥ礭κ
    
    // 2Ȥδ֤˰٥ȥʬ顢Υ٥ȥ
    // 礭׻ޤ
    Vec1_x = x-pre_x;
    Vec1_y = y-pre_y;
    Vec1_size = sqrt((float)(Vec1_x*Vec1_x + Vec1_y*Vec1_y));
    
    Vec2_x = x-next_x;
    Vec2_y = y-next_y;
    Vec2_size = sqrt((float)(Vec2_x*Vec2_x + Vec2_y*Vec2_y));
    
    // 2ĤΥ٥ȥ礭κΤ򥨥ͥ륮Ȥ֤ޤ
    return fabs(Vec1_size - Vec2_size)/(Vec1_size + Vec2_size);
}

// ߤγ¦˰ư褦Ȥ륨ͥ륮ʤ
// ߤĥ륨ͥ륮׻ޤ
float CalcMove(int pre_x,int pre_y,
	       int new_x, int new_y,	       
	       int old_x, int old_y)
{
    int Vec1_x,Vec1_y;   // newȤδ֤˰٥ȥʬ
    float Vec1_size;     // Ʊ礭
    
    int Vec2_x,Vec2_y;   // oldȤδ֤˰٥ȥʬ
    float Vec2_size;     // Ʊ礭
    
    float O_product;     // 2ĤΥ٥ȥΤʤ
    float SinTheta;       // 2ĤΥ٥ȥΤʤ٤Υ
    
    // 2Ȥδ֤˰٥ȥʬ顢Υ٥ȥ
    // 礭׻ޤ
    Vec1_x = new_x-pre_x;
    Vec1_y = new_y-pre_y;
    Vec1_size = sqrt((float)(Vec1_x*Vec1_x + Vec1_y*Vec1_y));
    // ȽŤʤäƤ0֤ޤ
    if(Vec1_size == 0.) return 0.;
    
    Vec2_x = old_x-pre_x;
    Vec2_y = old_y-pre_y;
    Vec2_size = sqrt((float)(Vec2_x*Vec2_x + Vec2_y*Vec2_y));
    // ȽŤʤäƤ0֤ޤ
    if(Vec2_size == 0.) return 0.;
    
    // 2ĤΥ٥ȥʬ顢γѤ׻ޤ
    O_product = (float)(Vec1_x*Vec2_y - Vec1_y*Vec2_x);
    
    // 2٥ȥγѤ礭顢ͤޤ
    SinTheta = O_product/(Vec1_size*Vec2_size);
    
    // 줿ͤ򥨥ͥ륮Ȥ
    return -SinTheta;
}

// Ϥ줿å󡢱߼󤫤ܱ߼
// ʰ֤ꤷޤ
void SelectNewPoint(
		    int l_image[3][3],int v,
		    int pre_x,int pre_y,
		    int x[1],int y[1],
		    int next_x,int next_y)
{
    int   i,j;
    int   old_x,old_y;    
    float Efield,Eangle,Edist,Emove;  // سФѤ륨ͥ륮Ǥ
    float Eall,Eall_min = 1000000.;  // ͥ륮¤ȤκǾͤǤ
    float MU_FIELD      = 40.;  // §˴Ť 
    float MU_ANGLE      = 5.;  // ֤ݤѤ  
    float MU_DISTANCE   = 5.;  // ͥ륮ؿνŤߤȤʤ  
    float MU_MOVE       = 1.;  // ޤ            


    old_x = x[0];
    old_y = y[0];
    // ˵8սȸΰ֤ΤǤλǺǤͥ륮㤤
    // ֤õޤ
    for(j = old_y - 1; j < old_y + 2; j++){
	for(i = old_x - 1; i < old_x + 2; i++){
	    // åΰˤˤĤƤΤ߷׻ޤ
	    if(l_image[i - old_x + 1][j - old_y + 1] != NO_USE){
		// ֥ͥ륮׻ޤ
		Efield = (float)l_image[i-old_x+1][j-old_y+1]*MU_FIELD/255;
		// 2Ȥʤ٤ľ˶դ롢ʤ߼
		// ʬ餫ˤ뤿Υͥ륮׻ޤ
		Eangle = CalcAngle(pre_x,pre_y,i,j,next_x,next_y)*MU_ANGLE;
		// 2˶դ褦Ȥ륨ͥ륮
		// ׻ޤ
		Edist = CalcDist(pre_x,pre_y,i,j,next_x,next_y)*MU_DISTANCE;
		// ߼礭뤿ᡢĤޤꡢĥ뤿
		// ͥ륮׻ޤ

		Emove = -CalcMove(pre_x,pre_y,i,j,old_x,old_y)*MU_MOVE;
		Emove += CalcMove(next_x,next_y,i,j,old_x,old_y)*MU_MOVE;
		
		// ƤΥͥ륮¤׻ޤ
		Eall = Efield + Eangle + Edist + Emove;
	
		// EallӤСͤǾͤȤ¸ޤ
		if(Eall < Eall_min){
		    Eall_min = Eall;
		    x[0] = i;
		    y[0] = j;
		}
	    }
	}
    }
}

// ͡ǥѤسԸХץ
// ⥸塼ʬ

module Snake(edge:input,result:output,circle_x,circle_y,roop_num:parameter)
int edge on box[BOX_SIZE][BOX_SIZE] cache 1;
int result on box[BOX_SIZE][BOX_SIZE];
int circle_x[P_NUM];  // ߼xɸǼ
int circle_y[P_NUM];  // ߼yɸǼ
int roop_num[1];      // ߼̤
#vios mutex circle_x off max
#vios mutex circle_y off max
{
    int temp_x[P_NUM];
    int temp_y[P_NUM];
#vios mutex temp_x off max
#vios mutex temp_y off max

    int flag;     // λɽե饰
#vios mutex flag off max
    {
	int i;
	for(i = 0; i < P_NUM; i++){
	    temp_x[i] = 0;
	    temp_y[i] = 0;
	}
    }

    for(flag = 0; flag < roop_num[0]; flag++){
	parallel{
	    int i,j,v;     // 롼ѿ
	    int my_x,my_y;
	    int x[1],y[1],pre_x,pre_y,next_x,next_y;
	    int l_image[3][3];  // ܲǤȼղǤǼ
	    int wdt,hgt;        // åβ礭
	    int old_x,old_y;    // θκɸ

	    my_x = hotx(edge);    // 󥰥åȤƬɸ
	    my_y = hoty(edge);    // ֤ޤ
	    
	    wdt = width(edge);    // åνġ礭
	    hgt = height(edge);   // ޤ

	    // Ƥα߼ɸФơκɸ󥰥å
	    // ޤޤƤ뤫ɤĴ٤ޤ
	    for(v = 0; v < P_NUM; v++){
		if(my_x <= circle_x[v] && circle_x[v] < my_x+BOX_SIZE){
		    if(my_y <= circle_y[v] && circle_y[v] < my_y+BOX_SIZE){
			// Ѥɸѿ˳Ǽޤ
			x[0] = circle_x[v];
			y[0] = circle_y[v];
			old_x = x[0];
			old_y = y[0];
			if(v == 0){
			    pre_x = circle_x[P_NUM-1];
			    pre_y = circle_y[P_NUM-1];
			    next_x = circle_x[v+1];
			    next_y = circle_y[v+1];
			}
			else if(v == P_NUM-1){
			    pre_x = circle_x[v-1];
			    pre_y = circle_y[v-1];
			    next_x = circle_x[0];
			    next_y = circle_y[0];
			}
			else{
			    pre_x = circle_x[v-1];
			    pre_y = circle_y[v-1];
			    next_x = circle_x[v+1];
			    next_y = circle_y[v+1];
			}
			// ܺɸβǤȡμ8˵βǤ
			// ѿ˳Ǽޤ
			for(j = old_y - 1; j < old_y + 2; j++){
			    // åΰξϤΰ֤
			    // ͤǼޤ
			    if(0 <= j && j < hgt){
				for(i = old_x - 1; i < old_x + 2; i++){
				    if(0 <= i && i < wdt){
					l_image[i - old_x + 1][j - old_y + 1] = edge[[i]][[j]];
				    }
				    // ʳξNO_USEޤ
				    else{
					l_image[i - old_x + 1][j - old_y + 1] = NO_USE;
				    }
				}
			    }
			    else{
			        l_image[i - old_x + 1][j - old_y + 1] = NO_USE;
			    }
			}
			// §˴Ťʰ֤õޤ
			SelectNewPoint(l_image,v,pre_x,pre_y,x,y,next_x,next_y);
			
			if(x[0] != old_x) temp_x[v] = x[0];
			if(y[0] != old_y) temp_y[v] = y[0];
		    }
		}
	    }
	}//  1st parallel end

	{// 줿ͤΤtemp뤿ᡢƤФͤcircle˽ᤷޤ
	    int i;
	    for(i = 0; i < P_NUM; i++){
		if(temp_x[i] != 0){
		    circle_x[i] = temp_x[i];
		    temp_x[i] = 0;
		}
		if(temp_y[i] != 0){
		    circle_y[i] = temp_y[i];
		    temp_y[i] = 0;
		}
	    }
	}
    }
    // ǽŪߤޤä־ץåȤޤ
    parallel{
	int i;
	int x,y;
	int my_x = hotx(edge);
	int my_y = hoty(edge);
	
	for(y = 0; y < BOX_SIZE; y++){
	    for(x = 0; x < BOX_SIZE; x++){
		if(x < width(result) && y < height(result))
		    result[x][y] = 255;
	
		for(i = 0; i < P_NUM; i++){
		    if(circle_x[i] == my_x+x && circle_y[i] == my_y+y)
			result[x][y] = 0;
		}
	    }
	}
    }
}
