/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  msgpopup.c
*********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "tcl.h"
#include "tk.h"
#include "msgpopup.h"


/**** Υåɽ ****
 * 󥿡ץ꥿εưԿΤǿ(Τѹ)
 */

int
msgpopup(char* type, char *msg)
{
    char buf[1024];
    char* result;
    Tcl_Interp* interp2;

    interp2 = Tcl_CreateInterp();
    if(Tcl_Init(interp2) == TCL_ERROR){
      fprintf(stderr, "Tcl_Init error: %s\n", interp2->result);
      return -1;
    }
    if( Tk_Init(interp2) == TCL_ERROR){
      fprintf(stderr,  "Tk_Init error: %s\n", interp2->result);
      return -1;
    }
    sprintf(buf, "wm withdraw .;tk_messageBox -parent .\
                  -type %s -message \"%s\"", type, msg);
    if(Tcl_Eval(interp2, buf) == TCL_ERROR){
      fprintf(stderr, "Interp error: %s\n", Tcl_GetStringResult(interp2));
      Tcl_DeleteInterp(interp2);
      return -1;
    }
    result = Tcl_GetStringResult(interp2);
    Tcl_DeleteInterp(interp2);
    if(strcmp(result,"yes")== 0) return 0;
    return -1;
}
