/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  ObjList.h
*********************************************************************/

#ifndef OBJLIST_H
#define OBJLIST_H

class Image;

//-----------------------------------------------
// Image Υ֥ȤΥꥹȤ¸륯饹
//-----------------------------------------------

class ObjectList
{
  private:
    Image*	image; //  ObjectList  image Ϻ
    ObjectList*	next;

    //  ID i_id d_id ĥΡɤΰļΥΡɤ֤
    ObjectList*	search_prev(int i_id, int d_id);
    //  ID i_id d_id ĥΡɤ֤
    ObjectList*	search(int i_id, int d_id);

  public:
    // 󥹥ȥ饯 & ǥȥ饯
    ObjectList();
    ObjectList(Image* img, ObjectList* n);
    ~ObjectList();

    // append() : βɲä
    // remove() : βꥹȤΤΤ
    // get()    : β

    int 	append(Image* img);
    int 	remove(int i_id, int d_id);
    int 	remove(Image* img);
    Image*	get(int i_id, int d_id);

    void	print(); // for debug
};

#endif /* OBJLIST_H */
