/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  conv.cc
    åκǾ̤ͤηѴԤ
*********************************************************************/

#include "conv.h"
#include "def.h"
#include "stack.h"
#include "table.h"
#include "ObjList.h"

// f_cvi(): åκǾ̤ͤ int Ѵ
int
f_cvi(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    int i;

    (void)TA; (void)FT; (void)OL;

    switch (ST.sttype())
    {
      case nt_int:
	return OKAY;
      case nt_real:
      case nt_complex:
	ST.pop(i);
	ST.push(i);
	return OKAY;
      default:
	return FAIL;
    }
}

// f_cvr(): åκǾ̤ͤ real Ѵ
int
f_cvr(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    float i;

    (void)TA; (void)FT; (void)OL;

    switch (ST.sttype())
    {
      case nt_real:
	return OKAY;
      case nt_int:
      case nt_complex:
	ST.pop(i);
	ST.push(i);
	return OKAY;
      default:
	return FAIL;
    }
}

// f_cvc(): åκǾ̤ͤ complex Ѵ
int
f_cvc(stack& ST, table& TA, ftable& FT, ObjectList& OL)
{
    complex i;

    (void)TA; (void)FT; (void)OL;

    switch (ST.sttype())
    {
      case nt_complex:
	return OKAY;
      case nt_int:
      case nt_real:
	ST.pop(i);
	ST.push(i);
	return OKAY;
      default:
	return FAIL;
    }
}
