/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  keyword.h
*********************************************************************/

#ifndef KEYWORD_H
#define KEYWORD_H

#include "stack.h"
#include "table.h"
#include "ftable.h"
#include "ObjList.h"

// ؿη
typedef int (*key_func_t)(stack&, table&, ftable&, ObjectList&);

struct keyword_t {
    char*	keyword;	// ̾
    key_func_t	f;		// ؿ
};

struct keyfunc_t {
    char*	keyfunc;	// ̾
    key_func_t	f;		// ؿ
    int 	in_num;		// ϲο
    int 	out_num;	// ϲο
    int 	param_num;	// ѥ᡼ο
};

keyword_t*	check_keyword(char*);
keyfunc_t*	check_keyfunc(char*);

#endif /* KEYWORD_H */
