/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  paralist.cc
    signal wait Ԥ
*********************************************************************/

#include <stdio.h>
#include <pthread.h>
#include "paralist.h"

paralist::paralist(paralist* n, int j_id)
{
    next = n;
    job_id = j_id;
}

// Υ ID Ǥõ
// ƬΥåݻޤ֤
paralist*
paralist::search(int j_id)
{
    paralist* p;
    pthread_mutex_lock(&lock);
    for (p = next; p != NULL; p = p->next) {
	if (p->job_id == j_id) {
	    return p;
	}
    }
    return NULL;
}

// ---- ѥ֥å᥽å ----

paralist::paralist()
{
    next = NULL;
    job_id = -1;
    pthread_mutex_init(&lock, NULL);
}

paralist::~paralist()
{
}

// signal ޤԤ褿餽 signal ˽񤫤Ƥ para_id ֤
int
paralist::wait(int j_id)
{
    paralist* p = search(j_id);
    if (p == NULL) {
	next = new paralist(next, j_id);
	p = next;
    }
    pthread_mutex_unlock(&lock);

    ipu_ipu msg;
    int para_id;
    p->queue.getmsg(msg);
    para_id = msg.para_info->para_id;
    delete msg.para_info;
    return para_id;
}

// signal 
int
paralist::signal(int j_id, int para_id)
{
    paralist* p = search(j_id);
    if (p == NULL) {
	next = new paralist(next, j_id);
	p = next;
    }
    pthread_mutex_unlock(&lock);

    ipu_ipu msg;
    msg.para_info = new para_id_info;
    msg.para_info->para_id = para_id;
    p->queue.putmsg(msg);
    return 0;
}
