/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  paralist.h
    signal wait Ԥ
*********************************************************************/

#ifndef PARALIST_H
#define PARALIST_H

#include <pthread.h>
#include "msgqueue.h"

//  ID Ȥ˥塼

class paralist {
  private:
    paralist*		next;
    int			job_id;
    pthread_mutex_t	lock;  // ƬǤΤ
    msgqueue		queue; // ǤΤ

    paralist(paralist* n, int job_id);
    paralist* paralist::search(int job_id);

  public:
    paralist();
    ~paralist();

    int wait(int job_id);
    int signal(int job_id, int para_id);
};

#endif /* PARALIST_H */
