/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  IpuList.h
    IPU ꥹ (IPU )
*********************************************************************/

class IpuList
{
  private:
    IpuList*	next;
    int 	ipu_no;		// IPU ֹ
    char*	hostname;	// IPU äƤۥ̾
    int 	ip1_num;	// ip1 ο
    int 	ipu_load;	// IPU ˤץο
    int 	ruser_load;	// IPU äƤۥȤ
    float	perform;	// CPU ǽ (⤤ۤǽ perform > 0)
    int 	ipu_num;	// IPU ο (Ƭ IpuList Τݻ)
    int 	total_ip1_num;	// ip1 οι (Ƭ IpuList Τݻ)

    IpuList(IpuList* n, int ipu_n, char* h_name, int ip1_n,
	    int r_load, float perf);
    IpuList* search(int ipu_n);
    IpuList* search(char* h_name);

  public:
    IpuList();
    ~IpuList();
    // IPU ꥹȤ IPU ä
    int   append(char* h_name, int ip1_n, int r_load, float perf);
    // IPU ٤񤭴(1䤹)
    void  add_ipu_load(char* h_name);
    void  add_ipu_load(int ipu_n);
    // IPU ٤񤭴(1餹)
    void  sub_ipu_load(char* h_name);
    void  sub_ipu_load(int ipu_n);
    // IPU ο
    int   get_ipu_num() { return ipu_num; };
    // ip1 ο
    int   get_ip1_num(char* h_name);
    int   get_ip1_num(int ipu_n);
    // ip1 οιפ
    int   get_total_ip1_num();
    // IPU ˤΰʳ٤񤭴
    void  set_ruser_load(char* h_name, int r_load);
    void  set_ruser_load(int ipu, int r_load);
    // IPU ˤΰʳ٤
    int   get_ruser_load(char* h_name);
    int   get_ruser_load(int ipu);
    // ޥΥѥեޥ󥹤񤭴
    void  set_perform(char* h_name, float perf);
    void  set_perform(int ipu, float perf);
    // ַڤ IPU ֹ֤
    int   get_light_weight_ipu_no();
    // IPU ֹ椫ۥ֤̾
    char* get_hostname(int ipu_n);
    // ۥ̾ IPU ֹ֤
    int   get_ipu_no(char* h_name);
};
