/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  genout.c
    
*********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include "transdefs.h"
#include "trans.h"

#define INDENT_WIDTH 4

/**  **/

int
gen_outf(char *form, ...)
{
    va_list vp;
    char buf[4096];

    va_start(vp, form);
    vsprintf(buf, form, vp);
    va_end(vp);
    return translator_output(buf);
}

/* ϤݤΥǥȴط */

static int indent_level = 0;

void
gen_indent_level_up(void)
{
    indent_level++;
}

void
gen_indent_level_down(void)
{
    indent_level--;
}

void
gen_indent(void)
{
    int i;
    for (i = 0; i < indent_level*INDENT_WIDTH; i++)
	gen_outf(" ");
}

void
gen_LC(void)
{
    gen_indent();
    gen_outf("{\n");
    gen_indent_level_up();
}

void
gen_RC(void)
{
    gen_indent_level_down();
    gen_indent();
    gen_outf("}\n");
}
