/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  macro.h
    ޥ
*********************************************************************/

#ifndef MACRO_H
#define MACRO_H

typedef struct macro_t_ {
    char *name;
    Tree *body;
    int  param_n; /* -1: ʤ, 0ʾ: θĿ */
} macro_t;

int macro_init(void);
int macro_term(void);
int macro_define(int (*get)(void), int (*unget)(int ch),
		 int (*get_identifier)(char *buf, int size),
		 int (*get_string)(char *buf, int size));
int macro_undef(int (*get)(void), int (*unget)(int ch),
		int (*get_identifier)(char *buf, int size));
macro_t *search_macro(char *);
char *replace_macro(macro_t *);

#endif /* MACRO_H */
