#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "tcl.h"
#include "vs_run.h"
#include "vs_quit.h"
#include "vs_connect.h"

/* Tcl/tkǸƤӽФνؿ */
char* current_filename = NULL;

int Vios_Init(Tcl_Interp* interp)
{
  static char buf[10] = "O.K.";
  static char VarLinkString[50] = "filename";

  Tcl_LinkVar(interp, VarLinkString, \
              (char* )(& current_filename), TCL_LINK_STRING);

  Tcl_CreateCommand(interp, "vscompile",    compile,       NULL, NULL);
  Tcl_CreateCommand(interp, "vsrun",        run,           NULL, NULL);
  Tcl_CreateCommand(interp, "vsd_run",      d_run,         NULL, NULL);
  Tcl_CreateCommand(interp, "vsdebug",      debug,         NULL, NULL);
  Tcl_CreateCommand(interp, "vsconnect",    om_connect,    NULL, NULL);
  Tcl_CreateCommand(interp, "vsdisconnect", om_disconnect, NULL, NULL);
  Tcl_CreateCommand(interp, "vscancel",     om_cancel,     NULL, NULL);
  Tcl_CreateCommand(interp, "vsquit",       try_quit,      NULL, NULL);
  Tcl_CreateCommand(interp, "vsom",         om_exec,       NULL, NULL);
  Tcl_CreateCommand(interp, "vsipu",        ipu_exec,      NULL, NULL);
  Tcl_SetResult(interp, buf, TCL_STATIC);
  return TCL_OK;
}
