#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>
#include "tcl.h"
#include "msgpopup.h"
#include "vpedefs.h"
#include "image.h"
#include "compile.h"
#include "com.h"
#include "protocol.h"
#include "port.h"

int		om_fd = -1;

/* ̤(餯Tcl¦б) */
int		modified_flag = 1;

int 
quit()
{
    vpe_om		msg;
    unsigned char	buf[8];

    if (om_fd >= 0) {
	msg.type = p_vo_quit;
	msg.size = 0;

	buf[0] = (unsigned char)((msg.type >> 24) & 0xff);
	buf[1] = (unsigned char)((msg.type >> 16) & 0xff);
	buf[2] = (unsigned char)((msg.type >>  8) & 0xff);
	buf[3] = (unsigned char)((msg.type      ) & 0xff);
	buf[4] = (unsigned char)((msg.size >> 24) & 0xff);
	buf[5] = (unsigned char)((msg.size >> 16) & 0xff);
	buf[6] = (unsigned char)((msg.size >>  8) & 0xff);
	buf[7] = (unsigned char)((msg.size      ) & 0xff);
	net_write(om_fd, buf, 8);
    }
    return 0;
}

int 
try_quit(ClientData clientdata, Tcl_Interp* interp,
	    int argc, char* argv[])
{
  int flag;

  if (modified_flag) {
    flag = msgpopup("yesnocancel", "Are you sure you want to quit tkvpe?");
    if(flag == 0){
      quit();
      Tcl_SetVar(interp, "result", "yes", 0); 
    }
  }
  return TCL_OK;
}
