#include <stdio.h>
#include <string.h>
#include "tcl.h"
#include "tk.h"
#include "vpedefs.h"
#include "ipustat.h"
#include "image.h"
#include "compile.h"
#include "com.h"
#include "protocol.h"
#include "msgpopup.h"
#include "port.h"

int 
compile(ClientData clientdata, Tcl_Interp* interp,
	   int argc, char* argv[])
/*ARGSUSED*/
{
  char *program;
  char buf[256];

  strcpy(buf, "InContents");
  if(Tcl_Eval(interp, buf)== TCL_ERROR){
    fprintf(stderr, "Interp error: %s\n",Tcl_GetStringResult(interp));
    return TCL_ERROR;
  }
  program = Tcl_GetVar(interp, "currentvalue",TCL_GLOBAL_ONLY );
  if(program == NULL){
    msgpopup("ok","File is Not Open!");
    return TCL_ERROR;
  }
  compile_module(program);
  return TCL_OK;
}

int
run(ClientData clientdata, Tcl_Interp* interp,
	   int argc, char* argv[])
/*ARGSUSED*/
{
  char *program;
  char buf[256];

  strcpy(buf, "InContents");
  if(Tcl_Eval(interp, buf)== TCL_ERROR){
    fprintf(stderr, "Interp error: %s\n",Tcl_GetStringResult(interp));
    return TCL_ERROR;
  }
  program = Tcl_GetVar(interp, "currentvalue", TCL_GLOBAL_ONLY );
   if(program == NULL){
    msgpopup("ok","File is Not Open!");
    return TCL_ERROR;
  }
 run_module(program);
  return TCL_OK;
}

int
debug(ClientData clientdata, Tcl_Interp* interp,
	   int argc, char* argv[])
/*ARGSUSED*/
{
  char *program;
  char buf[256];

  strcpy(buf, "InContents");
  if(Tcl_Eval(interp, buf)== TCL_ERROR){
    fprintf(stderr, "Interp error: %s\n",Tcl_GetStringResult(interp));
    return TCL_ERROR;
  }
  program = Tcl_GetVar(interp, "currentvalue", TCL_GLOBAL_ONLY );
   if(program == NULL){
    msgpopup("ok","File is Not Open!");
    return TCL_ERROR;
  }
 debug_module(program);
  return TCL_OK;
}

int
d_run(ClientData clientdata, Tcl_Interp* interp,
	   int argc, char* argv[])
/*ARGSUSED*/
{
  char *program;

  program = Tcl_GetVar(interp, "currentvalue", TCL_GLOBAL_ONLY );
  fprintf(stderr,"program: %s\n",program);
   if(program == NULL){
    msgpopup("ok","File is Not Open!");
    return TCL_ERROR;
  }
 d_run_module(program);
  return TCL_OK;
}
