/*********************************************************************
  Copyright (c) 1992-1999 Iwata Lab. All Rights Reserved.

  msgpopup.c
*********************************************************************/

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Form.h>
#include "msgpopup.h"

extern Widget toplevel;
static void popdown(Widget w, XtPointer closure, XtPointer call_data);

/**** Υåɽ ****/
void
msgpopup(char *msg)
{
    Widget popup, frame, ok;

    popup = XtVaCreatePopupShell("msgPopup", topLevelShellWidgetClass,
				 toplevel, NULL);
    frame = XtVaCreateManagedWidget("frame", formWidgetClass, popup, NULL);
    XtVaCreateManagedWidget("message", labelWidgetClass, frame,
			    XtNlabel, msg,
			    NULL);
    ok = XtVaCreateManagedWidget("dismiss", commandWidgetClass, frame, NULL);
    XtAddCallback(ok, XtNcallback, popdown, (XtPointer)popup);
    XtPopup(popup, XtGrabExclusive);
}

static void
popdown(Widget w, XtPointer closure, XtPointer call_data)
/*ARGSUSED*/
{
    XtPopdown((Widget)closure);
    XtDestroyWidget((Widget)closure);
}
